(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.SFUController = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
'use strict'

const createView = function(container) {
    //setup sigma
    const s = new sigma({
        renderer: {
            container: container,
            type: 'canvas'
        },
        settings: {
            minArrowSize: 3,
            edgeLabelSize: 'fixed'
        }
    });

    const refreshSigma = function(model) {
        s.graph.clear();
        s.refresh();

        s.graph.read(model);
        s.refresh();
    }

    const bindNodeClickEvents = function (handler) {
        const eventList = 'clickNode doubleClickNode rightClickNode';
        s.bind(eventList, handler);
    };

    return {
        s: s,
        bindNodeClickEvents: bindNodeClickEvents,
        refreshSigma: refreshSigma
    }
}

module.exports = {
    createView: createView
}
},{}],2:[function(require,module,exports){
'use strict'


const parser = require("./parser");
const graphView = require("./graph-view");
const tableView = require("./table-view");
const rest = require("./rest");

const config = {
    intervals: {
        poll: 3000
    }
};

const connect = function() {
    let freeze = false;
    const urlElem = document.getElementById("url");
    const roomNameElem = document.getElementById("roomName");
    const rawDisplay = document.getElementById("rawContent");
    const startButtonElem = document.getElementById("startButton");
    const freezeButtonElem = document.getElementById("freeze");
    startButtonElem.disabled = true;
    urlElem.disabled = true;
    roomNameElem.disabled = true;
    const url = urlElem.value;
    const roomName = roomNameElem.value;
    const api = rest.createConnection(url, roomName);
    let pollTimeout;
    const pollStats = function() {
        api.stats().then(function(stats){
            if (!freeze) {
                processAndDisplay(stats);
                pollTimeout = setTimeout(pollStats, config.intervals.poll);
            }
        }, function(e) {
            console.log("Failed to poll stats " + e);
            if (!freeze) {
                rawDisplay.innerHTML = "Failed to poll stats " + e;
                pollTimeout = setTimeout(pollStats, config.intervals.poll);
            }
        })
    }

    freezeButtonElem.addEventListener("click", function(){
        if (freezeButtonElem.innerText === "Freeze") {
            freeze = true;
            clearTimeout(pollTimeout);
            freezeButtonElem.innerText = "Unfreeze";
        } else {
            freeze = false;
            pollStats();
            freezeButtonElem.innerText = "Freeze";
        }
    });
    freezeButtonElem.disabled = false;

    const gView = graphView.createView('sigmaContainer');
    const tView = tableView.createMetricTable();
    let tData, gData;
    const processAndDisplay = function(stats) {
        rawDisplay.innerHTML = JSON.stringify(stats, null, 2);
        tData = parser.statsToTable(stats);
        gData = parser.statsToGraph(stats);
        gView.refreshSigma(gData);
        tView.updateMetricTable(tData.WCS, "WCS");
    }

    gView.bindNodeClickEvents(function(e){
        tView.updateMetricTable(tData[e.data.node.id], e.data.node.id);
    });
    //kick off stats polling
    pollStats();
}



module.exports = {
    connect: connect
}
},{"./graph-view":1,"./parser":3,"./rest":4,"./table-view":5}],3:[function(require,module,exports){
'use strict'

const statsToGraph = function(stats) {
    let g = {
        nodes: [],
        edges: []
    }

    const wcsId = "WCS";
    const edgeType = 'curvedArrow';
    let eIndex = 0;
    const fromServerColour = '#00ff40';
    const fromParticipantColour = '#3a8dc6';
    const deadTrackColour = '#ff2800';
    const nodeSize = 5;
    const edgeSize = 2;

    g.nodes.push({
        id: wcsId,
        label: wcsId,
        // Display attributes:
        x: 0,
        y: 0,
        size: nodeSize,
        color: fromServerColour
    });

    const calcPoints = function(radius, qty) {
        const ret = [];
        const stepRad = 360/qty * Math.PI / 180;
        for (let i = 0; i < qty; i++) {
            let angle = i * stepRad;
            let x = Math.cos(angle) * radius;
            let y = Math.sin(angle) * radius;
            ret.push({
                x: x,
                y: y
            });
        }
        return ret;
    }

    const points = calcPoints(800, stats.participants.length);
    stats.participants.forEach(function(participant){
        let count = 0;
        let point = points.pop();
        g.nodes.push({
            id: participant.nickName,
            label: participant.nickName,
            // Display attributes:
            x: point.x,
            y: point.y,
            size: nodeSize,
            color: fromParticipantColour
        });
        participant.outgoingTracks.forEach(function(track){
            if (track.composite) {
                for (const [key, value] of Object.entries(track.tracks)) {
                    g.edges.push({
                        id: 'e' + eIndex,
                        // Reference extremities:
                        source: participant.nickName,
                        target: wcsId,
                        label: value.id + "-" + key,
                        count: count++,
                        size: edgeSize,
                        type: edgeType,
                        color: value.alive ? fromParticipantColour : deadTrackColour
                    });
                    eIndex++;
                }
            } else {
                g.edges.push({
                    id: 'e' + eIndex,
                    // Reference extremities:
                    source: participant.nickName,
                    target: wcsId,
                    label: track.id,
                    count: count++,
                    size: edgeSize,
                    type: edgeType,
                    color: track.alive ? fromParticipantColour : deadTrackColour
                });
                eIndex++;
            }
        });
        for (const [key, value] of Object.entries(participant.incomingTracks)) {
            g.edges.push({
                id: 'e' + eIndex,
                // Reference extremities:
                source: wcsId,
                target: participant.nickName,
                label: value ? key + "-" + value : key,
                count: count++,
                size: edgeSize,
                type: edgeType,
                color: fromServerColour
            });
            eIndex++;
        }
    });
    return g;
}

const statsToTable = function(stats) {
    const NA = "NA";
    const tKey = function(str1, str2) {
        if (str1 && str2) {
            return str1.replaceAll(" ", "") + str2.replaceAll(" ", "");
        }
        return str1;
    }
    const trackToTable = function(track, nickName, quality) {
        return {
            metric: "track",
            type: track.type,
            participant: nickName,
            id: track.id,
            quality: quality,
            details: track
        }
    }
    const metricToTable = function(name, value, nickName) {
        return {
            metric: name,
            type: value,
            participant: nickName,
            id: NA,
            quality: NA,
            details: {}
        }
    }

    const metrics = {};
    metrics.WCS = [];
    let bitrate_in = 0;
    let tracks_in = 0;

    const src = {};
    stats.participants.forEach(function(participant){
        participant.outgoingTracks.forEach(function(track){
            if (track.composite) {
                for (const [key, value] of Object.entries(track.tracks)) {
                    src[tKey(value.id, key)] = value;
                    value.nickName = participant.nickName;
                    bitrate_in += value.bitrate;
                    tracks_in++;
                }
            } else {
                src[tKey(track.id)] = track;
                track.nickName = participant.nickName;
                bitrate_in += track.bitrate;
                tracks_in++;
            }
        });
    });
    let bitrate_out = 0;
    let tracks_out = 0;
    stats.participants.forEach(function(participant){
        for (const [key, value] of Object.entries(participant.incomingTracks)) {
            const srcTrack = src[tKey(key, value)];
            bitrate_out += srcTrack.bitrate;
            tracks_out++;
        }
    });
    metrics.WCS.push(metricToTable("participants", stats.participants.length, NA));
    metrics.WCS.push(metricToTable("bitrate_in", bitrate_in, NA));
    metrics.WCS.push(metricToTable("bitrate_out", bitrate_out, NA));
    metrics.WCS.push(metricToTable("tracks_in", tracks_in, NA));
    metrics.WCS.push(metricToTable("tracks_out", tracks_out, NA));
    stats.participants.forEach(function(participant){
        const pStats = [];
        let tracksIn = 0;
        let tracksOut = 0;
        let bitrateIn = 0;
        let bitrateOut = 0;
        participant.outgoingTracks.forEach(function(track){
            if (track.composite) {
                for (const [key, value] of Object.entries(track.tracks)) {
                    pStats.push(trackToTable(value, participant.nickName, key));
                    tracksOut++;
                    bitrateOut += value.bitrate;
                }
            } else {
                pStats.push(trackToTable(track, participant.nickName, "NA"));
                tracksOut++;
                bitrateOut += track.bitrate;
            }
        });
        for (const [key, value] of Object.entries(participant.incomingTracks)) {
            const srcTrack = src[tKey(key, value)];
            pStats.push(trackToTable(srcTrack, srcTrack.nickName, value));
            tracksIn++;
            bitrateIn += srcTrack.bitrate;
        }
        pStats.push(metricToTable("tracks_in", tracksIn, participant.nickName));
        pStats.push(metricToTable("bitrate_in", bitrateIn, participant.nickName));
        pStats.push(metricToTable("tracks_out", tracksOut, participant.nickName));
        pStats.push(metricToTable("bitrate_out", bitrateOut, participant.nickName));
        metrics[participant.nickName] = pStats;
    });

    return metrics;
}

module.exports = {
    statsToGraph: statsToGraph,
    statsToTable: statsToTable
}
},{}],4:[function(require,module,exports){
'use strict'

const SFU_PATH = "/rest-api/sfu/";

const createConnection = function(url, roomName) {
    const stats = function() {
        return send(url + SFU_PATH + "stats", {
            roomName: roomName
        });
    }
    return {
        stats: stats
    }
}


/** XHR WRAPPER **/
const send = function(uri, data, responseIsText) {
    return new Promise(function(resolve, reject) {
        var xhr = new XMLHttpRequest();
        if (data) {
            xhr.open('POST', uri, true);
            xhr.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        } else {
            xhr.open('GET', uri, true);
        }
        xhr.responseType = 'text';
        xhr.onload = function (e) {
            if (this.status === 200) {
                if (this.response) {
                    if (!responseIsText) {
                        resolve(JSON.parse(this.response));
                    } else {
                        resolve(this.response);
                    }
                } else {
                    resolve();
                }
            } else {
                reject(this);
            }
        };
        xhr.onreadystatechange = function () {
            if (xhr.readyState === 4){
                if(xhr.status === 200){
                    //success
                } else {
                    reject();
                }
            }
        };
        if (data) {
            xhr.send(JSON.stringify(data));
        } else {
            xhr.send();
        }
    });
};

module.exports = {
    createConnection: createConnection
}
},{}],5:[function(require,module,exports){
'use strict'

const createMetricTable = function() {
    const updateMetricTable = function(data, caption) {
        metricTableCaption.innerHTML = caption;
        metricTable.clear();
        data.forEach(function(value) {
            metricTable.row.add(value);
        });
        metricTable.draw();
    }

    //setup table
    const metricTable = $('#metricTable').DataTable({
        "columns": [
            {
                "className":      'details-control',
                "orderable":      false,
                "data":           null,
                "defaultContent": ''
            },
            {"data": "metric"},
            {"data": "type"},
            {"data": "participant"},
            {"data": "id"},
            {"data": "quality"}
        ]
    });

    const format = function(d) {
        let details =  '<table cellpadding="5" cellspacing="0" border="0" style="padding-left:50px;">';
        for (const [key, value] of Object.entries(d.details)) {
            details += '<tr>'+
                '<td>'+ key + '</td>'+
                '<td>'+ value + '</td>'+
                '</tr>';
        }
        details +='</table>';
        return details;
    }

    // Add event listener for opening and closing details
    $('#metricTableBody').on('click', 'td.details-control', function () {
        var tr = $(this).closest('tr');
        var row = metricTable.row( tr );

        if ( row.child.isShown() ) {
            // This row is already open - close it
            row.child.hide();
            tr.removeClass('shown');
        }
        else {
            // Open this row
            row.child( format(row.data()) ).show();
            tr.addClass('shown');
        }
    });

    const metricTableCaption = document.getElementById("metricTable").createCaption();



    return {
        updateMetricTable: updateMetricTable
    }
}

module.exports = {
    createMetricTable: createMetricTable
}
},{}]},{},[2])(2)
});
